diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index 6b1f24e..3dfb201 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -41,6 +41,7 @@
 #include "commands/tablespace.h"
 #include "miscadmin.h"
 #include "pgstat.h"
+#include "port/atomics.h"
 #include "postmaster/bgwriter.h"
 #include "postmaster/walwriter.h"
 #include "postmaster/startup.h"
@@ -51,7 +52,6 @@
 #include "replication/snapbuild.h"
 #include "replication/walreceiver.h"
 #include "replication/walsender.h"
-#include "storage/barrier.h"
 #include "storage/bufmgr.h"
 #include "storage/fd.h"
 #include "storage/ipc.h"
diff --git a/src/backend/main/main.c b/src/backend/main/main.c
index c018c90..3707998 100644
--- a/src/backend/main/main.c
+++ b/src/backend/main/main.c
@@ -33,8 +33,8 @@
 
 #include "bootstrap/bootstrap.h"
 #include "common/username.h"
+#include "port/atomics.h"
 #include "postmaster/postmaster.h"
-#include "storage/barrier.h"
 #include "storage/s_lock.h"
 #include "storage/spin.h"
 #include "tcop/tcopprot.h"
diff --git a/src/backend/postmaster/bgworker.c b/src/backend/postmaster/bgworker.c
index 8f62554..9249585 100644
--- a/src/backend/postmaster/bgworker.c
+++ b/src/backend/postmaster/bgworker.c
@@ -17,9 +17,9 @@
 #include "libpq/pqsignal.h"
 #include "miscadmin.h"
 #include "pgstat.h"
+#include "port/atomics.h"
 #include "postmaster/bgworker_internals.h"
 #include "postmaster/postmaster.h"
-#include "storage/barrier.h"
 #include "storage/dsm.h"
 #include "storage/ipc.h"
 #include "storage/latch.h"
diff --git a/src/backend/storage/ipc/latch.c b/src/backend/storage/ipc/latch.c
index 8488f94..b7e5129 100644
--- a/src/backend/storage/ipc/latch.c
+++ b/src/backend/storage/ipc/latch.c
@@ -56,9 +56,9 @@
 
 #include "miscadmin.h"
 #include "pgstat.h"
+#include "port/atomics.h"
 #include "portability/instr_time.h"
 #include "postmaster/postmaster.h"
-#include "storage/barrier.h"
 #include "storage/latch.h"
 #include "storage/pmsignal.h"
 #include "storage/shmem.h"
diff --git a/src/backend/storage/ipc/shm_toc.c b/src/backend/storage/ipc/shm_toc.c
index 55248c2..a065212 100644
--- a/src/backend/storage/ipc/shm_toc.c
+++ b/src/backend/storage/ipc/shm_toc.c
@@ -13,7 +13,7 @@
 
 #include "postgres.h"
 
-#include "storage/barrier.h"
+#include "port/atomics.h"
 #include "storage/shm_toc.h"
 #include "storage/spin.h"
 
diff --git a/src/backend/storage/lmgr/s_lock.c b/src/backend/storage/lmgr/s_lock.c
index 599940c..6f81838 100644
--- a/src/backend/storage/lmgr/s_lock.c
+++ b/src/backend/storage/lmgr/s_lock.c
@@ -51,7 +51,7 @@
 #include <unistd.h>
 
 #include "storage/s_lock.h"
-#include "storage/barrier.h"
+#include "port/atomics.h"
 
 
 #define MIN_SPINS_PER_DELAY 10
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
index 4e8dac6..0b85b7a 100644
--- a/src/include/pgstat.h
+++ b/src/include/pgstat.h
@@ -14,9 +14,9 @@
 #include "datatype/timestamp.h"
 #include "fmgr.h"
 #include "libpq/pqcomm.h"
+#include "port/atomics.h"
 #include "portability/instr_time.h"
 #include "postmaster/pgarch.h"
-#include "storage/barrier.h"
 #include "storage/proc.h"
 #include "utils/hsearch.h"
 #include "utils/relcache.h"
diff --git a/src/include/storage/barrier.h b/src/include/storage/barrier.h
deleted file mode 100644
index 6202e57..0000000
--- a/src/include/storage/barrier.h
+++ /dev/null
@@ -1,23 +0,0 @@
-/*-------------------------------------------------------------------------
- *
- * barrier.h
- *	  Memory barrier operations.
- *
- * Portions Copyright (c) 1996-2016, PostgreSQL Global Development Group
- * Portions Copyright (c) 1994, Regents of the University of California
- *
- * src/include/storage/barrier.h
- *
- *-------------------------------------------------------------------------
- */
-#ifndef BARRIER_H
-#define BARRIER_H
-
-/*
- * This used to be a separate file, full of compiler/architecture
- * dependent defines, but it's not included in the atomics.h
- * infrastructure and just kept for backward compatibility.
- */
-#include "port/atomics.h"
-
-#endif   /* BARRIER_H */
